---
title: FileError
slug: Web/API/FileError
tags:
  - API
  - File API
  - Files
  - Obsolete
  - Reference
---
<div>{{APIRef("File System API")}}{{obsolete_header}}</div>

<p>Represents an error that occurs while using the {{domxref("FileReader")}} interface.</p>

<div class="note">
<p><strong>Note:</strong> This interface is obsolete per the latest specification. Use the new DOM4 {{domxref("DOMError")}} interface instead.</p>
</div>

<p>In the <a href="/en-US/docs/Web/API/File_System_API/Introduction">File System API</a>, a <code>FileError</code> represents error conditions that you might encounter while accessing the file system using the asynchronous API. It extends the <code>FileError</code> interface described in <a class="external" href="http://dev.w3.org/2009/dap/file-system/pub/FileSystem/#bib-FILE-WRITER">File Writer</a> and adds several new error codes.</p>

<p><code>FileError</code> objects are passed to error callbacks. The objects have a code that shows the type of error that occurred.</p>

<h2 id="Best_practices">Best practices</h2>

<p>Most people don't read the page on errors and exceptions unless they're stumped. So the following are a few tips that could help you avoid some pitfalls.</p>

<h3 id="Error_callbacks_are_not_optional_for_your_sanity">Error callbacks are not optional for your sanity</h3>

<p>Although error callbacks are optional, you should include them in the arguments of the methods for the sake of the sanity of your users. A web app could fail for various reasons, so you don't want to spend the rest of your day guessing what's going on and going through maddening troubleshooting.</p>

<h3 id="Don't_run_your_app_from_file">Don't run your app from file://</h3>

<p>For security reasons, browsers do not allow you to run your app from <code>file://</code>. In fact, many of the powerful storage APIs (such as File System, BlobBuilder, and FileReader) throw errors if you run the app locally from <code>file://</code>. When you're just testing your app, and you don't want to set up a web server, you can bypass the security restriction on Chrome. Just start Chrome with the <code>--allow-file-access-from-files</code> flag. Use the flag only for testing purposes.</p>

<h2 id="Attribute">Attribute</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Attribute</th>
   <th scope="col">Type</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a><code>code</code></a></td>
   <td><code>unsigned short</code></td>
   <td>The most appropriate error code for the condition. See {{anch("Error codes")}} for possible values.</td>
  </tr>
 </tbody>
</table>

<h2 id="Error_codes">Error codes</h2>

<p>{{Note("Do not rely on the numeric values of the constants, which might change as the specifications continue to change. Use the constant names instead.")}}</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Constant</th>
   <th scope="col">Value</th>
   <th scope="col">Description</th>
  </tr>
  <tr>
   <td><code><a>ENCODING_ERR</a></code></td>
   <td>5</td>
   <td>The URL is malformed. Make sure that the URL is complete and valid.</td>
  </tr>
  <tr>
   <td><code><a>INVALID_MODIFICATION_ERR</a></code></td>
   <td>9</td>
   <td>The modification requested is not allowed. For example, the app might be trying to move a directory into its own child or moving a file into its parent directory without changing its name.</td>
  </tr>
  <tr>
   <td><code><a>INVALID_STATE_ERR</a></code></td>
   <td>7</td>
   <td>The operation cannot be performed on the current state of the interface object. For example, the state that was cached in an interface object has changed since it was last read from disk.</td>
  </tr>
  <tr>
   <td><code><a>NO_MODIFICATION_ALLOWED_ERR</a></code></td>
   <td>6</td>
   <td>The state of the underlying file system prevents any writing to a file or a directory.</td>
  </tr>
  <tr>
   <td><code><a>NOT_FOUND_ERR</a></code></td>
   <td>1</td>
   <td>A required file or directory could not be found at the time an operation was processed. For example, a file did not exist but was being opened.</td>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code><a>NOT_READABLE_ERR</a></code></td>
   <td>4</td>
   <td>The file or directory cannot be read, typically due to permission problems that occur after a reference to a file has been acquired (for example, the file or directory is concurrently locked by another application).</td>
  </tr>
  <tr>
   <td><code><a>PATH_EXISTS_ERR</a></code></td>
   <td>12</td>
   <td>The file or directory with the same path already exists.</td>
  </tr>
  <tr>
   <td><code><a>QUOTA_EXCEEDED_ERR</a></code></td>
   <td>10</td>
   <td>Either there's not enough remaining storage space or the storage quota was reached and the user declined to give more space to the database. To ask for more storage, see <a class="external" href="http://code.google.com/chrome/whitepapers/storage.html">Managing HTML5 Offline Storage</a>.</td>
  </tr>
  <tr>
   <td><code><a>SECURITY_ERR</a></code></td>
   <td>2</td>
   <td>
    <p>Access to the files were denied for one of the following reasons:</p>

    <ul>
     <li>The files might be unsafe for access within a Web application.</li>
     <li>Too many calls are being made on file resources.</li>
     <li>Other unspecified security error code or situations.</li>
    </ul>
   </td>
  </tr>
  <tr>
   <td><code><a>TYPE_MISMATCH_ERR</a></code></td>
   <td>11</td>
   <td>The app looked up an entry, but the entry found is of the wrong type. For example, the app is asking for a directory, when the entry is really a file.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.FileError")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/File_System_API/Introduction">Basic Concepts About the File System API</a></li>
 <li>{{domxref("FileReader")}}</li>
 <li>{{domxref("File")}}</li>
 <li>{{domxref("Blob")}}</li>
 <li>{{spec("http://www.w3.org/TR/file-system-api/#errors-and-exceptions", "Specification: FileAPI Errors and exceptions", "WD")}}</li>
</ul>
